package jdk.internal.org.objectweb.asm.tree;

import jdk.internal.org.objectweb.asm.Label;
import jdk.internal.org.objectweb.asm.MethodVisitor;
import java.util.Arrays;
import java.util.ArrayList;
import jdk.internal.org.objectweb.asm.TypePath;
import java.util.List;

public class LocalVariableAnnotationNode extends TypeAnnotationNode
{
    public List<LabelNode> start;
    public List<LabelNode> end;
    public List<Integer> index;
    
    public LocalVariableAnnotationNode(int n, TypePath typePath, LabelNode[] array, LabelNode[] array2, int[] array3, String s) {
        this(327680, n, typePath, array, array2, array3, s);
    }
    
    public LocalVariableAnnotationNode(int n, int n2, TypePath typePath, LabelNode[] a, LabelNode[] a2, int[] array, String s) {
        super(n, n2, typePath, s);
        (this.start = new ArrayList(a.length)).addAll(Arrays.asList(a));
        (this.end = new ArrayList(a2.length)).addAll(Arrays.asList(a2));
        this.index = new ArrayList(array.length);
        for (int length = array.length, i = 0; i < length; ++i) {
            this.index.add(Integer.valueOf(array[i]));
        }
    }
    
    public void accept(MethodVisitor methodVisitor, boolean b) {
        Label[] start = new Label[this.start.size()];
        Label[] end = new Label[this.end.size()];
        int[] index = new int[this.index.size()];
        for (int i = 0; i < start.length; ++i) {
            start[i] = ((LabelNode)this.start.get(i)).getLabel();
            end[i] = ((LabelNode)this.end.get(i)).getLabel();
            index[i] = (int)this.index.get(i);
        }
        this.accept(methodVisitor.visitLocalVariableAnnotation(this.typeRef, this.typePath, start, end, index, this.desc, true));
    }
}
